scala.util.parsing.json

# Lexer

#### class Lexer extends StdLexical with ImplicitConversions

Source
  Lexer.scala

Linear Supertypes
ImplicitConversions, StdLexical, StdTokens, Lexical, Tokens, Scanners, Parsers, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Lexer
2. ImplicitConversions
3. StdLexical
4. StdTokens
5. Lexical
6. Tokens
7. Scanners
8. Parsers
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new Lexer()

### Type Members

1. #### type Elem = Char

   the type of input elements the provided parsers consume (When consuming invidual characters, a parser is typically called a scanner, which produces tokens that are consumed by what is normally called a parser.

   the type of input elements the provided parsers consume (When consuming invidual characters, a parser is typically called a scanner, which produces tokens that are consumed by what is normally called a parser. Nonetheless, the same principles apply, regardless of the input type.)

   Definition Classes
     Scanners → Parsers

2. #### case class Error(msg: String, next: Input) extends NoSuccess with Product with Serializable

   The fatal failure case of ParseResult: contains an error-message and the remaining input.

3. #### case class ErrorToken(msg: String) extends Token with Product with Serializable

   A class of error tokens.

4. #### case class Failure(msg: String, next: Input) extends NoSuccess with Product with Serializable

   The failure case of `ParseResult`: contains an error-message and the remaining input.

5. #### case class Identifier(chars: String) extends Token with Product with Serializable

   The class of identifier tokens

6. #### type Input = Reader[Elem]

   The parser input is an abstract reader of input elements, i.

   The parser input is an abstract reader of input elements, i.e. the type of input the parsers in this component expect.

   Definition Classes
     Parsers

7. #### case class Keyword(chars: String) extends Token with Product with Serializable

   The class of keyword tokens

8. #### sealed abstract class NoSuccess extends ParseResult[Nothing]

   A common super-class for unsuccessful parse results.

9. #### case class NumericLit(chars: String) extends Token with Product with Serializable

   The class of numeric literal tokens

10. #### trait OnceParser[+T] extends Parser[T]

    A parser whose `~` combinator disallows back-tracking.

11. #### sealed abstract class ParseResult[+T] extends AnyRef

    A base class for parser results.

12. #### abstract class Parser[+T] extends (Input) ⇒ ParseResult[T]

    The root class of parsers.

13. #### class Scanner extends Reader[Token]

    `Scanner` is essentially¹ a parser that produces `Token`s from a stream of characters.

14. #### case class StringLit(chars: String) extends Token with Product with Serializable

    The class of string literal tokens

15. #### case class Success[+T](result: T, next: Input) extends ParseResult[T] with Product with Serializable

    The success case of `ParseResult`: contains the result and the remaining input.

16. #### abstract class Token extends AnyRef

    Objects of this type are produced by a lexical parser or ``scanner, and consumed by a parser.``

17. #### case class ~[+a, +b](_1: a, _2: b) extends Product with Serializable

    A wrapper over sequence of matches.

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Lexer to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (Lexer, B)

   Implicit information
     This member is added by an implicit conversion from Lexer to ArrowAssoc[Lexer] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### object EOF extends Token with Product with Serializable

   A class for end-of-file tokens

9. #### object NoSuccess

   An extractor so `NoSuccess(msg, next)` can be used in matches.

10. #### def OnceParser[T](f: (Input) ⇒ ParseResult[T]): Parser[T] with OnceParser[T]

    Definition Classes
      Parsers

11. #### def Parser[T](f: (Input) ⇒ ParseResult[T]): Parser[T]

    Definition Classes
      Parsers

12. #### def accept[U](expected: String, f: PartialFunction[Elem, U]): Parser[U]

    The parser that matches an element in the domain of the partial function `f`.

    The parser that matches an element in the domain of the partial function `f`.

    If `f` is defined on the first element in the input, `f` is applied to it to produce this parser's result.

    Example: The parser `accept("name", {case Identifier(n) => Name(n)})` accepts an `Identifier(n)` and returns a `Name(n)`

    expected

      a description of the kind of element this parser expects (for error messages)

    f

      a partial function that determines when this parser is successful and what its output is

    returns

      A parser that succeeds if `f` is applicable to the first element of the input, applying `f` to it to produce the result.

    Definition Classes
      Parsers

13. #### def accept[ES](es: ES)(implicit arg0: (ES) ⇒ List[Elem]): Parser[List[Elem]]

    A parser that matches only the given list of element `es`.

    A parser that matches only the given list of element `es`.

    `accept(es)` succeeds if the input subsequently provides the elements in the list `es`.

    es

      the list of expected elements

    returns

      a Parser that recognizes a specified list of elements

    Definition Classes
      Parsers

14. #### implicit def accept(e: Elem): Parser[Elem]

    A parser that matches only the given element `e`.

    A parser that matches only the given element `e`.

    The method is implicit so that elements can automatically be lifted to their parsers. For example, when parsing `Token`s, `Identifier("new")` (which is a `Token`) can be used directly, instead of first creating a `Parser` using `accept(Identifier("new"))`.

    e

      the `Elem` that must be the next piece of input for the returned parser to succeed

    returns

      a `tParser` that succeeds if `e` is the next available input.

    Definition Classes
      Parsers

15. #### def acceptIf(p: (Elem) ⇒ Boolean)(err: (Elem) ⇒ String): Parser[Elem]

    A parser matching input elements that satisfy a given predicate.

    A parser matching input elements that satisfy a given predicate.

    `acceptIf(p)(el => "Unexpected "+el)` succeeds if the input starts with an element `e` for which `p(e)` is true.

    p

      A predicate that determines which elements match.

    err

      A function from the received element into an error message.

    returns

      A parser for elements satisfying p(e).

    Definition Classes
      Parsers

16. #### def acceptMatch[U](expected: String, f: PartialFunction[Elem, U]): Parser[U]

    The parser that matches an element in the domain of the partial function `f`.

    The parser that matches an element in the domain of the partial function `f`.

    If `f` is defined on the first element in the input, `f` is applied to it to produce this parser's result.

    Example: The parser `acceptMatch("name", {case Identifier(n) => Name(n)})` accepts an `Identifier(n)` and returns a `Name(n)`

    expected

      a description of the kind of element this parser expects (for error messages)

    f

      a partial function that determines when this parser is successful and what its output is

    returns

      A parser that succeeds if `f` is applicable to the first element of the input, applying `f` to it to produce the result.

    Definition Classes
      Parsers

17. #### def acceptSeq[ES](es: ES)(implicit arg0: (ES) ⇒ Iterable[Elem]): Parser[List[Elem]]

    A parser that matches only the given scala.collection.Iterable collection of elements `es`.

    A parser that matches only the given scala.collection.Iterable collection of elements `es`.

    `acceptSeq(es)` succeeds if the input subsequently provides the elements in the iterable `es`.

    es

      the list of expected elements

    returns

      a Parser that recognizes a specified list of elements

    Definition Classes
      Parsers

18. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown
      ClassCastException

      if the receiver object is not an instance of the erasure of type `T0`.

19. #### def chainl1[T, U](first: ⇒ Parser[T], p: ⇒ Parser[U], q: ⇒ Parser[(T, U) ⇒ T]): Parser[T]

    A parser generator that, roughly, generalises the `rep1sep` generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    A parser generator that, roughly, generalises the `rep1sep` generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    first

      a parser that parses the first element

    p

      a parser that parses the subsequent elements

    q

      a parser that parses the token(s) separating the elements, yielding a left-associative function that combines two elements into one

    Definition Classes
      Parsers

20. #### def chainl1[T](p: ⇒ Parser[T], q: ⇒ Parser[(T, T) ⇒ T]): Parser[T]

    A parser generator that, roughly, generalises the rep1sep generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    A parser generator that, roughly, generalises the rep1sep generator so that `q`, which parses the separator, produces a left-associative function that combines the elements it separates.

    From: J. Fokker. Functional parsers. In J. Jeuring and E. Meijer, editors, Advanced Functional Programming, volume 925 of Lecture Notes in Computer Science, pages 1--23. Springer, 1995.

    p

      a parser that parses the elements

    q

      a parser that parses the token(s) separating the elements, yielding a left-associative function that combines two elements into one

    Definition Classes
      Parsers

21. #### def chainr1[T, U](p: ⇒ Parser[T], q: ⇒ Parser[(T, U) ⇒ U], combine: (T, U) ⇒ U, first: U): Parser[U]

    A parser generator that generalises the `rep1sep` generator so that `q`, which parses the separator, produces a right-associative function that combines the elements it separates.

    A parser generator that generalises the `rep1sep` generator so that `q`, which parses the separator, produces a right-associative function that combines the elements it separates. Additionally, the right-most (last) element and the left-most combining function have to be supplied.

    rep1sep(p: Parser[T], q) corresponds to chainr1(p, q ^^ cons, cons, Nil) (where val cons = (x: T, y: List[T]) => x :: y)

    p

      a parser that parses the elements

    q

      a parser that parses the token(s) separating the elements, yielding a right-associative function that combines two elements into one

    combine

      the "last" (left-most) combination function to be applied

    first

      the "first" (right-most) element to be combined

    Definition Classes
      Parsers

22. #### def charSeq: Parser[String]

23. #### def checkKeyword(xs: List[Any]): Product with Serializable with Token

24. #### def chrExcept(cs: Char*): Parser[Elem]

    A character-parser that matches any character except the ones given in `cs` (and returns it).

    A character-parser that matches any character except the ones given in `cs` (and returns it).

    Definition Classes
      Lexical

25. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

26. #### def comment: Parser[Any]

    Attributes
      protected
    Definition Classes
      StdLexical

27. #### def commit[T](p: ⇒ Parser[T]): Parser[T]

    Wrap a parser so that its failures become errors (the `|` combinator will give up as soon as it encounters an error, on failure it simply tries the next alternative).

    Wrap a parser so that its failures become errors (the `|` combinator will give up as soon as it encounters an error, on failure it simply tries the next alternative).

    Definition Classes
      Parsers

28. #### def delim: Parser[Token]

    Attributes
      protected
    Definition Classes
      StdLexical

29. #### val delimiters: HashSet[String]

    The set of delimiters (ordering does not matter).

    The set of delimiters (ordering does not matter).

    Definition Classes
      StdLexical

30. #### def digit: Parser[Elem]

    A character-parser that matches a digit (and returns it).

    A character-parser that matches a digit (and returns it).

    Definition Classes
      Lexical

31. #### def elem(e: Elem): Parser[Elem]

    A parser that matches only the given element `e`.

    A parser that matches only the given element `e`.

    `elem(e)` succeeds if the input starts with an element `e`.

    e

      the `Elem` that must be the next piece of input for the returned parser to succeed

    returns

      a `Parser` that succeeds if `e` is the next available input (and returns it).

    Definition Classes
      Parsers

32. #### def elem(kind: String, p: (Elem) ⇒ Boolean): Parser[Elem]

    A parser matching input elements that satisfy a given predicate.

    A parser matching input elements that satisfy a given predicate.

    `elem(kind, p)` succeeds if the input starts with an element `e` for which `p(e)` is true.

    kind

      The element kind, used for error messages

    p

      A predicate that determines which elements match.

    returns

    Definition Classes
      Parsers

33. #### def ensuring(cond: (Lexer) ⇒ Boolean, msg: ⇒ Any): Lexer

    Implicit information
      This member is added by an implicit conversion from Lexer to Ensuring[Lexer] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

34. #### def ensuring(cond: (Lexer) ⇒ Boolean): Lexer

    Implicit information
      This member is added by an implicit conversion from Lexer to Ensuring[Lexer] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

35. #### def ensuring(cond: Boolean, msg: ⇒ Any): Lexer

    Implicit information
      This member is added by an implicit conversion from Lexer to Ensuring[Lexer] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

36. #### def ensuring(cond: Boolean): Lexer

    Implicit information
      This member is added by an implicit conversion from Lexer to Ensuring[Lexer] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

37. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

38. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

39. #### def err(msg: String): Parser[Nothing]

    A parser that results in an error.

    A parser that results in an error.

    msg

      The error message describing the failure.

    returns

      A parser that always fails with the specified error message.

    Definition Classes
      Parsers

40. #### def errorToken(msg: String): Token

    This token is produced by a scanner `Scanner` when scanning failed.

    This token is produced by a scanner `Scanner` when scanning failed.

    Definition Classes
      Tokens

41. #### def expPart: Parser[String]

42. #### def exponent: Parser[Elem]

43. #### def failure(msg: String): Parser[Nothing]

    A parser that always fails.

    A parser that always fails.

    msg

      The error message describing the failure.

    returns

      A parser that always fails with the specified error message.

    Definition Classes
      Parsers

44. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

45. #### implicit def flatten2[A, B, C](f: (A, B) ⇒ C): (~[A, B]) ⇒ C

    Definition Classes
      ImplicitConversions

46. #### implicit def flatten3[A, B, C, D](f: (A, B, C) ⇒ D): (~[~[A, B], C]) ⇒ D

    Definition Classes
      ImplicitConversions

47. #### implicit def flatten4[A, B, C, D, E](f: (A, B, C, D) ⇒ E): (~[~[~[A, B], C], D]) ⇒ E

    Definition Classes
      ImplicitConversions

48. #### implicit def flatten5[A, B, C, D, E, F](f: (A, B, C, D, E) ⇒ F): (~[~[~[~[A, B], C], D], E]) ⇒ F

    Definition Classes
      ImplicitConversions

49. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from Lexer to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

50. #### def fracPart: Parser[String]

51. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

52. #### def guard[T](p: ⇒ Parser[T]): Parser[T]

    A parser generator for guard expressions.

    A parser generator for guard expressions. The resulting parser will fail or succeed just like the one given as parameter but it will not consume any input.

    p

      a `Parser` that is to be applied to the input

    returns

      A parser that returns success if and only if `p` succeeds but never consumes any input

    Definition Classes
      Parsers

53. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

54. #### implicit def headOptionTailToFunList[A, T](f: (List[A]) ⇒ T): (~[A, Option[List[A]]]) ⇒ T

    Definition Classes
      ImplicitConversions

55. #### def hexDigit: Parser[Elem]

56. #### val hexDigits: Set[Char]

57. #### def identChar: Parser[Elem]

    Returns the legal identifier chars, except digits.

    Returns the legal identifier chars, except digits.

    Definition Classes
      StdLexical

58. #### def intList: Parser[String]

59. #### def intPart: Parser[String]

60. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

61. #### def letter: Parser[Elem]

    A character-parser that matches a letter (and returns it).

    A character-parser that matches a letter (and returns it).

    Definition Classes
      Lexical

62. #### def log[T](p: ⇒ Parser[T])(name: String): Parser[T]

    A helper method that turns a `Parser` into one that will print debugging information to stdout before and after being applied.

    A helper method that turns a `Parser` into one that will print debugging information to stdout before and after being applied.

    Definition Classes
      Parsers

63. #### def mkList[T]: (~[T, List[T]]) ⇒ collection.immutable.List[T]

    Given a concatenation with a repetition (list), move the concatenated element into the list

    Given a concatenation with a repetition (list), move the concatenated element into the list

    Definition Classes
      Parsers

64. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

65. #### def nonzero: Parser[Elem]

66. #### def not[T](p: ⇒ Parser[T]): Parser[Unit]

    Wrap a parser so that its failures and errors become success and vice versa -- it never consumes any input.

    Wrap a parser so that its failures and errors become success and vice versa -- it never consumes any input.

    Definition Classes
      Parsers

67. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

68. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

69. #### def number: Parser[String]

70. #### def opt[T](p: ⇒ Parser[T]): Parser[Option[T]]

    A parser generator for optional sub-phrases.

    A parser generator for optional sub-phrases.

    `opt(p)` is a parser that returns `Some(x)` if `p` returns `x` and `None` if `p` fails.

    p

      A `Parser` that is tried on the input

    returns

      a `Parser` that always succeeds: either with the result provided by `p` or with the empty result

    Definition Classes
      Parsers

71. #### def phrase[T](p: Parser[T]): Parser[T]

    A parser generator delimiting whole phrases (i.

    A parser generator delimiting whole phrases (i.e. programs).

    `phrase(p)` succeeds if `p` succeeds and no input is left over after `p`.

    p

      the parser that must consume all input for the resulting parser to succeed.

    returns

      a parser that has the same result as `p`, but that only succeeds if `p` consumed all the input.

    Definition Classes
      Parsers

72. #### def positioned[T <: Positional](p: ⇒ Parser[T]): Parser[T]

    `positioned` decorates a parser's result with the start position of the input it consumed.

    `positioned` decorates a parser's result with the start position of the input it consumed.

    p

      a `Parser` whose result conforms to `Positional`.

    returns

      A parser that has the same behaviour as `p`, but which marks its result with the start position of the input it consumed, if it didn't already have a position.

    Definition Classes
      Parsers

73. #### def processIdent(name: String): Product with Serializable with Token

    Attributes
      protected
    Definition Classes
      StdLexical

74. #### def rep[T](p: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for repetitions.

    A parser generator for repetitions.

    `rep(p)` repeatedly uses `p` to parse the input until `p` fails (the result is a List of the consecutive results of `p`).

    p

      a `Parser` that is to be applied successively to the input

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input.

    Definition Classes
      Parsers

75. #### def rep1[T](first: ⇒ Parser[T], p0: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for non-empty repetitions.

    A parser generator for non-empty repetitions.

    `rep1(f, p)` first uses `f` (which must succeed) and then repeatedly uses `p` to parse the input until `p` fails (the result is a `List` of the consecutive results of `f` and `p`)

    first

      a `Parser` that parses the first piece of input

    p0

      a `Parser` that is to be applied successively to the rest of the input (if any) -- evaluated at most once, and only when necessary

    returns

      A parser that returns a list of results produced by first applying `f` and then repeatedly `p` to the input (it only succeeds if `f` matches).

    Definition Classes
      Parsers
    Annotations
      @migration
    Migration

      (Changed in version 2.9.0) The `p0` call-by-name arguments is evaluated at most once per constructed Parser object, instead of on every need that arises during parsing.

76. #### def rep1[T](p: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for non-empty repetitions.

    A parser generator for non-empty repetitions.

    `rep1(p)` repeatedly uses `p` to parse the input until `p` fails -- `p` must succeed at least once (the result is a `List` of the consecutive results of `p`)

    p

      a `Parser` that is to be applied successively to the input

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input (and that only succeeds if `p` matches at least once).

    Definition Classes
      Parsers

77. #### def rep1sep[T](p: ⇒ Parser[T], q: ⇒ Parser[Any]): Parser[List[T]]

    A parser generator for non-empty repetitions.

    A parser generator for non-empty repetitions.

    `rep1sep(p, q)` repeatedly applies `p` interleaved with `q` to parse the input, until `p` fails. The parser `p` must succeed at least once.

    p

      a `Parser` that is to be applied successively to the input

    q

      a `Parser` that parses the elements that separate the elements parsed by `p` (interleaved with `q`)

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input (and that only succeeds if `p` matches at least once). The results of `p` are collected in a list. The results of `q` are discarded.

    Definition Classes
      Parsers

78. #### def repN[T](num: Int, p: ⇒ Parser[T]): Parser[List[T]]

    A parser generator for a specified number of repetitions.

    A parser generator for a specified number of repetitions.

    `repN(n, p)` uses `p` exactly `n` time to parse the input (the result is a `List` of the `n` consecutive results of `p`).

    num

      the exact number of times `p` must succeed

    p

      a `Parser` that is to be applied successively to the input

    returns

      A parser that returns a list of results produced by repeatedly applying `p` to the input (and that only succeeds if `p` matches exactly `n` times).

    Definition Classes
      Parsers

79. #### def repsep[T](p: ⇒ Parser[T], q: ⇒ Parser[Any]): Parser[List[T]]

    A parser generator for interleaved repetitions.

    A parser generator for interleaved repetitions.

    `repsep(p, q)` repeatedly uses `p` interleaved with `q` to parse the input, until `p` fails. (The result is a `List` of the results of `p`.)

    Example: `repsep(term, ",")` parses a comma-separated list of term's, yielding a list of these terms.

    p

      a `Parser` that is to be applied successively to the input

    q

      a `Parser` that parses the elements that separate the elements parsed by `p`

    returns

      A parser that returns a list of results produced by repeatedly applying `p` (interleaved with `q`) to the input. The results of `p` are collected in a list. The results of `q` are discarded.

    Definition Classes
      Parsers

80. #### val reserved: HashSet[String]

    The set of reserved identifiers: these will be returned as `Keyword`s.

    The set of reserved identifiers: these will be returned as `Keyword`s.

    Definition Classes
      StdLexical

81. #### def sign: Parser[Elem]

82. #### def string: Parser[String]

    A string is a collection of zero or more Unicode characters, wrapped in double quotes, using backslash escapes (cf.

    A string is a collection of zero or more Unicode characters, wrapped in double quotes, using backslash escapes (cf. http://www.json.org/).

83. #### def success[T](v: T): Parser[T]

    A parser that always succeeds.

    A parser that always succeeds.

    v

      The result for the parser

    returns

      A parser that always succeeds, with the given result `v`

    Definition Classes
      Parsers

84. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

85. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

86. #### def token: Parser[Token]

    A parser that produces a token (from a stream of characters).

    A parser that produces a token (from a stream of characters).

    Definition Classes
      Lexer → StdLexical → Scanners

87. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

88. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

89. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

90. #### def whitespace: Parser[List[Elem]]

    A parser for white-space -- its result will be discarded.

    A parser for white-space -- its result will be discarded.

    Definition Classes
      Lexer → StdLexical → Scanners

91. #### def whitespaceChar: Parser[Elem]

    A character-parser that matches a white-space character (and returns it).

    A character-parser that matches a white-space character (and returns it).

    Definition Classes
      Lexical

92. #### def zero: Parser[String]

93. #### def →[B](y: B): (Lexer, B)

    Implicit information
      This member is added by an implicit conversion from Lexer to ArrowAssoc[Lexer] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Lexer to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lexer: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from Lexer to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lexer: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def lastNoSuccess: NoSuccess

   Definition Classes
     Parsers
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) lastNoSuccess was not thread-safe and will be removed in 2.11.0

2. #### def lastNoSuccess_=(x: NoSuccess): Unit

   Definition Classes
     Parsers
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) lastNoSuccess was not thread-safe and will be removed in 2.11.0

3. #### def x: Lexer

   Implicit information
     This member is added by an implicit conversion from Lexer to ArrowAssoc[Lexer] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lexer: ArrowAssoc[Lexer]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

4. #### def x: Lexer

   Implicit information
     This member is added by an implicit conversion from Lexer to Ensuring[Lexer] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lexer: Ensuring[Lexer]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from ImplicitConversions

### Inherited from StdLexical

### Inherited from StdTokens

### Inherited from Lexical

### Inherited from Tokens

### Inherited from Scanners

### Inherited from Parsers

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Lexer to StringAdd

### Inherited by implicit conversion any2stringfmt from Lexer to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from Lexer to ArrowAssoc[Lexer]

### Inherited by implicit conversion any2Ensuring from Lexer to Ensuring[Lexer]

### Ungrouped